
#include "minlog.h"


void empty( set S )
{
	S->lowbits = 0;
	S->highbits = 0;
}

 

int isempty( set S )
{
	return !(S->lowbits || S->highbits);
}
 

int hin( int item, halfset S )
{
	return ((S & (1 << item)) != 0);
}


int in( int item, set S )
{
	if ( item < 32 ) return hin( item, S->lowbits );
	return hin( item-32, S->highbits );
}


void putin( int item, set S )
{
	if (item < 32 ) S->lowbits |= ((halfset)1 << item);	
	else S->highbits |= (1 << (item-32));
}
 
void putout( int item, set S )
{
	if (item < 32) S->lowbits &= ~((halfset)1 << item);
        else S->highbits &= ~((halfset)1 << (item-32));
}


int unequal( set S1, set S2 )
{
	return (S1->lowbits != S2->lowbits || S1->highbits != S2->highbits);
}


void copyset(set fromset, set toset)
{
	toset->lowbits = fromset->lowbits;
        toset->highbits = fromset->highbits;
}


void low_intersect(set S, halfset H)
{
	S->lowbits &= H;
}


void intersect(set S1, set S2)
{
	S1->lowbits &= S2->lowbits;
	S1->highbits &= S2->highbits;
}

 
void addto(set S1, set S2)
{
	S1->lowbits |= S2->lowbits;
	S1->highbits |= S2->highbits;
}
